import unittest
from owncloud.trusted import convert_trusted_configuration


class TestTrustedConverter(unittest.TestCase):

    def test_convert(self):

        input = """
        <?php
$CONFIG = array (
  'instanceid' => 'oc4c5c522950',
  'passwordsalt' => 'c27c6ca1b655ee3bb04f4120f726ac',
  'trusted_domains' =>
  array(
    0 => 'localhost'
  ),
  'datadirectory' => '/data',
  'dbtype' => 'mysql',
  'version' => '6.0.3.1',
  'dbname' => 'owncloud',
  'dbhost' => 'localhost',
  'dbtableprefix' => 'oc_',
  'dbuser' => 'oc_bob',
  'dbpassword' => '6481ff1d07911652e7f2ca2aba2f6a',
  'installed' => true,
);
        """

        expected= """
        <?php
$CONFIG = array (
  'instanceid' => 'oc4c5c522950',
  'passwordsalt' => 'c27c6ca1b655ee3bb04f4120f726ac',
  'trusted_domains' => array('test.domain:1000'),
  'datadirectory' => '/data',
  'dbtype' => 'mysql',
  'version' => '6.0.3.1',
  'dbname' => 'owncloud',
  'dbhost' => 'localhost',
  'dbtableprefix' => 'oc_',
  'dbuser' => 'oc_bob',
  'dbpassword' => '6481ff1d07911652e7f2ca2aba2f6a',
  'installed' => true,
);
        """

        self.assertEquals(expected, convert_trusted_configuration(input, 'test.domain:1000'))

